using AmqpTest.Amqp;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace AmqpTest
{
	public class Worker : BackgroundService
	{
		private readonly ILogger<Worker> _logger;
		private readonly AmqpSubscribe _subscribe;

		public Worker(ILogger<Worker> logger, AmqpSubscribe subscribe)
		{
			_logger = logger;
			_subscribe = subscribe;

		}

		public override Task StartAsync(CancellationToken cancellationToken)
		{
			_logger.LogInformation("------StartAsync");

			return base.StartAsync(cancellationToken);
		}

		public override Task StopAsync(CancellationToken cancellationToken)
		{
			_logger.LogInformation("------StopAsync");

			return base.StopAsync(cancellationToken);
		}

		protected override async Task ExecuteAsync(CancellationToken stoppingToken)
		{
			while (!stoppingToken.IsCancellationRequested)
			{
				_logger.LogInformation("------ExecuteAsync");
				
				await _subscribe.BeginListen();
				
				_logger.LogWarning("밢AMQPӽ30룬Ȼ...");
				await Task.Delay(30000, stoppingToken);
			}
		}
	}
}
